===========
Main module
===========

.. contents:: Overview
   :local:

For more details regarding the main classes, see:

.. toctree::
   :maxdepth: 1

   nngt/graph-classes
   nngt/main-functions
   nngt/side-classes

.. automodule:: nngt
   :noindex:
   :no-members:

.. currentmodule:: nngt

.. autosummary::

    nngt.Graph
    :members:
    nngt.GroupProperty
    :members:
    nngt.MetaGroup
    :members:
    nngt.Network
    :members:
    nngt.NeuralGroup
    :members:
    nngt.NeuralPop
    :members:
    nngt.SpatialGraph
    :members:
    nngt.SpatialNetwork
    :members:
    nngt.generate
    nngt.get_config
    nngt.load_from_file
    nngt.num_mpi_processes
    nngt.on_master_process
    nngt.save_to_file
    nngt.seed
    nngt.set_config
    nngt.use_backend


Details
=======

.. module:: nngt


.. autoclass:: Graph

.. autoclass:: GroupProperty

.. autoclass:: MetaGroup

.. autoclass:: Network

.. autoclass:: NeuralGroup

.. autoclass:: NeuralPop

.. autoclass:: SpatialGraph

.. autoclass:: SpatialNetwork

.. autofunction:: generate

.. autofunction:: get_config

.. autofunction:: load_from_file

.. autofunction:: num_mpi_processes

.. autofunction:: on_master_process

.. autofunction:: save_to_file

.. autofunction:: seed

.. autofunction:: set_config

.. autofunction:: use_backend


.. toctree::
   :hidden:

   analysis
   core
   generation
   geometry
   lib
   plot
   simulation
